﻿UsePNGImageEncoder()

Global f$="Arial";font name
Global fs=64     ;font size
Enumeration
  #ca
  #fb
  #ip
  #tt
EndEnumeration

Enumeration
  #file_quit
  #file_save
EndEnumeration

Global iw,ih
Global ipx=0
Global ipy=0
Global mpx,mpy

Procedure drawcan(xx,yy)
  StartDrawing(CanvasOutput(0))
  Box(0,0,640,480,0)
  DrawImage(ImageID(0),xx,yy)
  StopDrawing()
EndProcedure


Procedure cleanup()
  If IsFont(0)
    FreeFont(0)
  EndIf
  If IsImage(0)
    FreeImage(0)  
  EndIf
EndProcedure

Procedure MakeText()
  cleanup() 
  m$=GetGadgetText(#tt);"Dzhigurda"
                       ;If LoadFont(0,"Delta Ray",64)
  ip$=GetGadgetText(#ip)
  If ip$<>"" And LoadFont(0,f$,fs)
    hbmp2.l=LoadImage(2,ip$)
    If hbmp2
      
    StartDrawing(CanvasOutput(#ca))
    DrawingFont( FontID(0) )
    iw=TextWidth(m$)
    ih=TextHeight(m$)
    StopDrawing()
    ;    hbmp0.l=CreateImage(0,w,h,32,RGBA(0,0,0,255))
    hbmp0.l=CreateImage(0, iw, ih, 32, #PB_Image_Transparent)
    StartDrawing(ImageOutput(0))
    DrawingMode(#PB_2DDrawing_AlphaBlend)
    DrawingFont( FontID(0) )
    k=255
    DrawText(0,0,m$,RGBA(k, k, k, 255), RGBA(0, 0, 0, 0))
    StopDrawing()
    
    hbmp1.l=CreateImage(1,iw,ih, 32, #PB_Image_Transparent)
    ;hbmp2.l=LoadImage(2,"line.bmp")
    
    hdc.l=CreateCompatibleDC_(0)
    hdc2.l=CreateCompatibleDC_(0)
    brush.l = CreatePatternBrush_(hbmp2)
    SelectObject_(hDC, brush)
    SelectObject_(hDC, hbmp1)
    PatBlt_(hDC,0,0,iw,ih+1,#PATCOPY)
    DeleteObject_(brush)
    
    StartDrawing(ImageOutput(1))
    DrawingMode(#PB_2DDrawing_AlphaChannel)
    For x=0 To iw-1
      For y=0 To ih-1
        cl=Point(x,y)
        Box( x,y,1,1,RGBA(Red(cl),Green(cl),Blue(cl),255) )
      Next y
    Next x
    StopDrawing()
    
    SelectObject_(hDC, hbmp0)
    SelectObject_(hDC2, hbmp1)
    
    res.l=BitBlt_(hdc,0,0,iw,ih,hdc2,0,0,#SRCAND)
    DeleteDC_(hdc)
    DeleteDC_(hdc2)
    ;;SaveImage(0,"ttt.png",#PB_ImagePlugin_PNG,0)
    If StartDrawing(CanvasOutput(#ca))
      Box(0,0,640,200,0)
      DrawAlphaImage(ImageID(0),0,0)
      StopDrawing()
      FreeFont(0)
    EndIf
    ;cleanup shit
    FreeImage(1)
    FreeImage(2)
    ipx=0
    ipy=0
    Drag = #False
  Else
    MessageRequester("image happens","Can't load "+ip$)
    EndIf;if hbmp2
  Else
    MessageRequester("font happens","Can't load "+f$)
  EndIf;If ip$<>"" And LoadFont(0,f$,fs)
  
EndProcedure

Procedure choosefont()
  Result = FontRequester(f$, fs, #PB_FontRequester_Effects)
  If Result
    f$=SelectedFontName()
    fs=SelectedFontSize()
    SetGadgetText(#fb,f$+","+Str(fs))
    ;    Message$ = "You have selected following font:"  + #LF$ 
    ;     Message$ + "Name:  " + SelectedFontName()       + #LF$
    ;     Message$ + "Size:  " + Str(SelectedFontSize())  + #LF$
    ;     Message$ + "Color: " + Str(SelectedFontColor()) + #LF$
    ;     If SelectedFontStyle() & #PB_Font_Bold
    ;       Message$ + "Bold" + #LF$
    ;     EndIf
    ;     If SelectedFontStyle() & #PB_Font_StrikeOut
    ;       Message$ + "StrikeOut" + #LF$
    ;     EndIf
    ;     If SelectedFontStyle() & #PB_Font_Underline
    ;       Message$ + "Underline" + #LF$
    ;    EndIf
    ; Else 
    ;    Message$ = "The requester was canceled."
    MakeText()
  EndIf
  
EndProcedure

If OpenWindow(0, 0, 0, 640, 280, "Text Draw", #PB_Window_SystemMenu | #PB_Window_ScreenCentered|#PB_Window_MinimizeGadget)
  CanvasGadget(#ca, 0, 0, 640, 200)
  ButtonGadget(#fb, 0, 200, 640, 20, "Arial,24")
  StringGadget(#tt, 0, 220, 640, 20, "TextDraw",#ES_CENTER);, #PB_String_BorderLess|#ES_CENTER)
  StringGadget(#ip, 0, 240, 640, 20, "line.bmp", #PB_String_BorderLess|#ES_CENTER)
;write settings
If OpenPreferences("tdraw.ini")
  PreferenceGroup("Settings")
  f$=ReadPreferenceString("FontName","Arial")
  fs=ReadPreferenceInteger("FontSize",24)
  in$=ReadPreferenceString("ImageName","")
  SetGadgetText(#ip,in$)
 ClosePreferences()
EndIf

;hints
GadgetToolTip(#ca,"Drag image by mouse")
GadgetToolTip(#fb,"Click to choose font")
GadgetToolTip(#tt,"Type text here")
GadgetToolTip(#ip,"Drag'n'drop image for text")
  ;menu
  If CreateMenu(0, WindowID(0))    ; menu creation starts....
    MenuTitle("File")
    MenuItem(#file_save, "Save")
    MenuItem(#file_quit, "Quit")
  EndIf
  
  EnableGadgetDrop(#ip,#PB_Drop_Files,#PB_Drag_Copy)
  ;init variables for drag   
  ipx=0
  ipy=0
  Drag = #False
  
  
  Repeat
    Event = WaitWindowEvent()
  If GetAsyncKeyState_(#VK_ESCAPE)&$8000;=-32767
    Break
  EndIf
 
    Select Event;If Event = #PB_Event_Gadget
      Case #PB_Event_Menu
        Select EventMenu()
          Case #file_quit
            Break
          Case #file_save
            If IsImage(0)
              Pattern$ = "PNG (*.png)"
              Pattern = 0    ; use the first of the three possible patterns as standard
              File$ = SaveFileRequester("Please choose file to save", StandardFile$, Pattern$, 0)
              If File$
                e$=LCase( Mid(File$,Len(File$)-3) )
                If e$<>".png"
                  File$+".png"
                EndIf
                
                SaveImage(0,File$,#PB_ImagePlugin_PNG,0)
              EndIf
            EndIf
            
            
        EndSelect        
      Case #PB_Event_GadgetDrop
        If EventGadget()=#ip
          Files$ = EventDropFiles()
          ;Count  = CountString(Files$, Chr(10)) + 1
          ;For i = 1 To Count
          fi$=StringField(Files$, 1, Chr(10))
          ;Debug fi$
          If FileSize(fi$)>0
            SetGadgetText(#ip,fi$)
            maketext()
          EndIf
          ;Next i
        EndIf
        
      Case #PB_Event_Gadget
        Select EventGadget()
            ;           Case #ip
            ;             If EventType()=#PB_EventType_Change
            ;               maketext()
            ;             EndIf
          Case #fb
            choosefont()
          Case #tt
            If EventType()= #PB_EventType_Change
              maketext()
              ;               ipx=0
              ;               ipy=0
              ;               Drag = #False
            EndIf
          Case #ca
            Select EventType()
              Case #PB_EventType_LeftButtonDown
                
                x = GetGadgetAttribute(#ca, #PB_Canvas_MouseX)
                y = GetGadgetAttribute(#ca, #PB_Canvas_MouseY)
                If x >= ipx And x <  ipx + iw
                  If y >= ipy And y < ipy + ih
                    mpx=x
                    mpy=y
                    Drag = #True
                  EndIf
                EndIf
                
              Case #PB_EventType_LeftButtonUp
                Drag = #False
                x = GetGadgetAttribute(#ca, #PB_Canvas_MouseX)
                y = GetGadgetAttribute(#ca, #PB_Canvas_MouseY)
                ipx=ipx-(mpx-x)
                ipy=ipy-(mpy-y)
                
              Case #PB_EventType_MouseMove
                If GetGadgetAttribute(0, #PB_Canvas_Buttons) & #PB_Canvas_LeftButton
                  If Drag = #True
                    x = GetGadgetAttribute(#ca, #PB_Canvas_MouseX)
                    y = GetGadgetAttribute(#ca, #PB_Canvas_MouseY)
                    StartDrawing(CanvasOutput(#ca))
                    If IsImage(0)
                      Box(0,0,640,200,0)
                      DrawAlphaImage(ImageID(0),ipx-(mpx-x),ipy-(mpy-y))
                      StopDrawing()
                    EndIf
                  EndIf
                EndIf
            EndSelect
            
        EndSelect
    EndSelect;EndIf;If Event = #PB_Event_Gadget
    
  Until Event = #PB_Event_CloseWindow
EndIf
cleanup()
;write settings
If CreatePreferences("tdraw.ini")
  PreferenceGroup("Settings")
  WritePreferenceString("FontName",f$)
  WritePreferenceInteger("FontSize",fs)
  WritePreferenceString("ImageName",GetGadgetText(#ip))
 ClosePreferences()
EndIf

; IDE Options = PureBasic 5.30 (Windows - x86)
; CursorPosition = 136
; FirstLine = 134
; Folding = -
; EnableXP
; UseIcon = tdraw.ico
; Executable = tdraw.exe